const { ipcRenderer, remote } = require('electron');
const mainProcess = remote.require('./main');
const spawn = require('child_process').spawn;

const neverRemindForUpdate = 1;

var userTotalQuota = mainProcess.getTotalQuota();
var userUsedQuota = mainProcess.getUsedQuota();
var userVerified = mainProcess.getIfUserNeedVerification();
var cryptoStatus = mainProcess.checkCryptoStatus();
var cryptoUnlocked = mainProcess.cryptoStarted();

window.onload = function () {
    setInterval(() => {

        let newTotalQuota = mainProcess.getTotalQuota();
        let newUserUsedQuota = mainProcess.getUsedQuota();
        let newUserVerified = mainProcess.getIfUserNeedVerification();
        let newCryptoStartedValue = mainProcess.cryptoStarted();

        if (userTotalQuota != newTotalQuota) {
            mainProcess.updateInfo('newTotalQuota', newTotalQuota);
            userTotalQuota = newTotalQuota;
        }

        if (userUsedQuota != newUserUsedQuota) {
            mainProcess.updateInfo('newUserUsedQuota', newUserUsedQuota);
            userUsedQuota = newUserUsedQuota;
        }

        if (userVerified != newUserVerified) {
            mainProcess.updateInfo('newUserVerified', newUserVerified);
            userVerified = newUserVerified;
        }

        let newCryptoStatus = mainProcess.checkCryptoStatus();
        if (cryptoStatus !== newCryptoStatus) {
            mainProcess.updateInfo('newCryptoStatus', newCryptoStatus);
            cryptoStatus = newCryptoStatus;
        }

        if (newCryptoStartedValue !== cryptoUnlocked) {
            mainProcess.updateInfo('cryptoUnlockStatusChanged', newCryptoStartedValue);
            cryptoUnlocked = newCryptoStartedValue;
        }

    }, 2000);

    setInterval(() => {

        let currentUser = mainProcess.getUserName();
        if (currentUser !== null && currentUser !== "") {
            mainProcess.checkForUpdates();

            setTimeout(function () {
                if (mainProcess.newVersionChecker()) {
                    let nextNotificationTime = mainProcess.getNextNotificationTime();
                    let now = Date.now();

                    if (nextNotificationTime !== null && nextNotificationTime !== neverRemindForUpdate && nextNotificationTime !== 0 && nextNotificationTime <= now) {
                        // console.log('Background worker - update notify');
                        mainProcess.initiateUpdateNotification();
                        mainProcess.setNextNotificationTime();
                    }
                }
                //WAITING SO THAT THE CHECK FOR UPDATE CALL CAN RETURN VALUES
            }, 2500);
        }
        // 5 minutes in miliseconds == 300000;
    }, 300000);
}

ipcRenderer.on('initiate-restart', function () {

    const restartProcess1 = spawn('node', [__dirname + '/js/restart1.js'], {
        detached: true,
        env: process.env,
        stdio: 'ignore'
    });

    restartProcess1.unref();
});