var { ipcRenderer, shell, remote } = require('electron');
const mainProcess = remote.require('./main');

document.addEventListener('dragover', function (event) {
    event.preventDefault();
    return false;
}, false);

document.addEventListener('drop', function (event) {
    event.preventDefault();
    return false;
}, false);

var RegisterApp = angular.module('RegisterApp', []);

RegisterApp.controller('RegController', [function RegisterController() {

    var vm = this;

    vm.getBackToLogin = function () {
        ipcRenderer.send("return-to-login");
    }

    vm.fbContinue = function () {
        ipcRenderer.send('continue-with-facebook')
    }

    vm.submitRegister = function (user, pass, agreement) {
        // console.log('agreement = ' + agreement);
        // console.log('vm.password = ' + vm.password);
        // console.log('vm.confirmPassword = ' + vm.confirmPassword);

        if (vm.password != vm.confirmPassword) {
            mainProcess.showError('Please provide identical passwords');

        }
        else if (agreement != true) {
            mainProcess.showMessage('You need to agree to our Terms of Service in order to register');
        }
        else {
            initiateLoading(3000);
            ipcRenderer.send('submit-register', [user, pass, agreement]);
        }
    }

    // When already have an account is clicked I need to pass the parameter to change windows so
    // that app shouldn't be close

}]);


var initiateLoading = function (spinningTime) {
    document.body.classList.add('loading');
    setTimeout(
        function () {
            document.body.classList.remove('loading');
        }, spinningTime);
}