var { ipcRenderer, shell, remote } = require('electron');
var ref = require('ref');
var fs = require('fs');
const mainProcess = remote.require('./main');

// Prevent opening files from drag and drop
document.addEventListener('dragover', function (event) {
    event.preventDefault();
    return false;
}, false);

document.addEventListener('drop', function (event) {
    event.preventDefault();
    return false;
}, false);


var wrong = document.getElementById('wrong');

//main module for the startscreen window
var loginApp = angular.module('LoginApp', []);

loginApp.controller('SignInController', [function LoginController() {

    var vm = this;

    vm.spanClicked = function () {
        if (vm.boxChecker) {
            vm.boxChecker = false;
        } else {
            vm.boxChecker = true;
        }
    };

    vm.fbContinue = function () {
        ipcRenderer.send('continue-with-facebook');
    }

    vm.forgotPassword = function (userName) {

        if (userName != undefined && userName != "") {
            ipcRenderer.send('forgot-password', userName);
        } else {
            mainProcess.showError("Please provide a valid email address");
        }
    }


    // var signUp = document.getElementById('sign-link');
    // signUp.addEventListener('click', function (event) {
    //     shell.openExternal('https://my.pcloud.com/#page=register');
    // });


    vm.logIn = function (user, pass, savePass) {
        initiateLoading(3000);
        ipcRenderer.send('log-in', [user, pass, savePass]);
        vm.password = "";
    };

    vm.signUp = function () {
        ipcRenderer.send('sign-up');
    };

    var unlinkButton = document.getElementById('unlink-button');
    unlinkButton.addEventListener('click', function (event) {

        vm.usernameLock = false;
        vm.usernameText = "";
        vm.password = "";
        unlinkButton.style.visibility = 'hidden';
        ipcRenderer.send('login-screen-unlink-pressed')
    });

    var username = mainProcess.getUserName();

    var emailField = document.getElementById('email-field');


    if (username == null) {
        vm.usernameText = "";
        unlinkButton.style.visibility = 'hidden';
        emailField.style.width = "96%";
        emailField.style.pointerEvents = "auto";

    } else {
        vm.usernameText = username;
        vm.password = "";
        vm.usernameLock = true;
        unlinkButton.style.visibility = 'visible';
        emailField.style.width = "74%";
        emailField.style.pointerEvents = "none";
    }

}]);

//display the current status
ipcRenderer.on('status', (event, args) => {
    wrong.innerHTML = 'Status: ' + args[0] + ' ' + args[1];
});

var initiateLoading = function (spinningTime) {
    document.body.classList.add('loading');
    setTimeout(
        function () {
            document.body.classList.remove('loading');
        }, spinningTime);
}