var { ipcRenderer, remote } = require('electron');
const mainProcess = remote.require('./main');

var extAccountScope = null;

document.addEventListener('dragover', function (event) {
    event.preventDefault();
    return false;
}, false);

document.addEventListener('drop', function (event) {
    event.preventDefault();
    return false;
}, false);

var VirtualFolderApp = angular.module('VirtualFolderApp', []);

VirtualFolderApp.controller('vFController', function ($scope) {

    var vm = this;
    extAccountScope = $scope;
    vm.arrayToDisplay = null;
    vm.elementsType = null;
    vm.disableGenCopyButton = true;

    vm.iconPicker = function () {
        iconLocation = "";
        if (vm.elementsType === 'files') {
            iconLocation = "img/shares/icons/unknown.png";
        } else {
            iconLocation = "img/shares/folder-linux.png";
        }
        return iconLocation;
    }

    vm.activityInitiated = function () {
        if (vm.disableGenCopyButton) {
            vm.disableGenCopyButton = false;
        }
    }

    vm.generateAndCopy = function (vFName) {

        if (vFName != undefined) {
            mainProcess.generateVirtualFolder(vFName, vm.elementsType, vm.arrayToDisplay);
        }
    }

    vm.closevFWindow = function () {
        ipcRenderer.send("close-vf-window");
    }

});

ipcRenderer.on('virtual-folder-info', (event, args) => {

    if (extAccountScope != null) {
        extAccountScope.$apply(function () {
            extAccountScope.vm.arrayToDisplay = args[0];
            extAccountScope.vm.elementsType = args[1];
        })
    }
});

function initiateLoading(spinningTime) {
    document.body.classList.add('loading');
    setTimeout(
        function () {
            document.body.classList.remove('loading');
        }, spinningTime);
}